package cn.pluss.platform.controller;

import cn.pluss.platform.api.PageInfo;
import cn.pluss.platform.api.Result;
import cn.pluss.platform.api.ResultGenerator;
import cn.pluss.platform.constants.ProjectConstant;
import cn.pluss.platform.deviceSignUnbind.DeviceSignUnbindService;
import cn.pluss.platform.entity.DeviceSignUnbind;
import cn.pluss.platform.util.StringUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping("/deviceSignUnbind")
@Api(value = "DeviceSignUnbind控制类", tags = {"DeviceSignUnbind接口"})
public class DeviceSignUnbindController {

    @Resource
    private DeviceSignUnbindService deviceSignUnbindService;

    @GetMapping
    @ApiOperation(value = "获取全部", notes = "返回分页过后的数据", httpMethod = "GET")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "page", value = "查询页码", paramType = "query", dataType = "Integer", defaultValue = "0"),
            @ApiImplicitParam(name = "size", value = "每页数据量", paramType = "query", dataType = "Integer", defaultValue = "0")
    })
    public Result<PageInfo<DeviceSignUnbind>> list(@RequestParam(defaultValue = "1") Integer page, @RequestParam(defaultValue = "10") Integer size) {
        if (size == null || size == 0) {
            size = ProjectConstant.PAGE_SIZE;
        }
        if (page == null || page == 0) {
            page = 1;
        }
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("pageSize", size);
        map.put("offset", (page - 1) * size);
        List<DeviceSignUnbind> deviceSignUnbindList = deviceSignUnbindService.queryDeviceSignUnbindPage(map);
        Integer count = deviceSignUnbindService.queryDeviceSignUnbindPageCount(map);
        //返回参数
        PageInfo pager = new PageInfo<>(count.longValue(), (long) StringUtil.getPageCount(count, size), page.longValue(), size.longValue(), deviceSignUnbindList);
        return ResultGenerator.genSuccessResult(pager);
    }

    @PostMapping
    @ApiOperation(value = "添加数据", notes = "添加新的数据", httpMethod = "POST")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "DeviceSignUnbind", value = "待添加的DeviceSignUnbind实例", paramType = "body", dataType = "DeviceSignUnbind", required = true)
    })
    public Result add(@RequestBody DeviceSignUnbind deviceSignUnbind) {
        deviceSignUnbindService.save(deviceSignUnbind);
        return ResultGenerator.genSuccessResult();
    }

    @DeleteMapping("/{id}")
    @ApiOperation(value = "删除数据", notes = "根据id删除数据", httpMethod = "DELETE")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "查询的id实例", paramType = "path", dataType = "Integer", required = true)
    })
    public Result delete(@PathVariable Integer id) {
        deviceSignUnbindService.removeById(id);
        return ResultGenerator.genSuccessResult();
    }

    @PutMapping
    @ApiOperation(value = "更新数据", notes = "根据内容更新数据", httpMethod = "PUT")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "DeviceSignUnbind", value = "更新的DeviceSignUnbind实例", paramType = "body", dataType = "DeviceSignUnbind", required = true)
    })
    public Result update(@RequestBody DeviceSignUnbind deviceSignUnbind) {
        deviceSignUnbindService.updateById(deviceSignUnbind);
        return ResultGenerator.genSuccessResult();
    }

    @GetMapping("/{id}")
    @ApiOperation(value = "获取单个值", notes = "查看单个项目的内容", httpMethod = "GET")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "查询的id", paramType = "path", required = true, dataType = "Integer", defaultValue = "0")
    })
    public Result detail(@PathVariable Long id) {
        DeviceSignUnbind deviceSignUnbind = new DeviceSignUnbind();
        deviceSignUnbind.setId(id.intValue());
        deviceSignUnbind = deviceSignUnbindService.queryDeviceSignUnbind(deviceSignUnbind);
        return ResultGenerator.genSuccessResult(deviceSignUnbind);
    }

    @GetMapping(value = "/applyDeviceSignUnbind")
    @ApiOperation(value = "设备激活/解绑申请", notes = "设备激活/解绑申请", httpMethod = "GET")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "orderNo", value = "订单号", paramType = "orderNo", required = true, dataType = "orderNo"),
            @ApiImplicitParam(name = "soleCode", value = "唯一编码", paramType = "soleCode", required = true, dataType = "soleCode"),
            @ApiImplicitParam(name = "sn", value = "sn码", paramType = "sn", required = true, dataType = "sn"),
    })
    public Result applyDeviceSignUnbind(@RequestParam(value = "orderNo") String orderNo, @RequestParam(value = "soleCode") String soleCode, @RequestParam(value = "sn") String sn) {
        return deviceSignUnbindService.applyDeviceSignUnbind(orderNo, soleCode, sn);
    }
}

